﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml.Linq;

namespace LINQ_SelectMany
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnCarregarXML_Click(object sender, EventArgs e)
        {
            try
            {
                XElement dadosXML = XElement.Load(@"c:\dados\XML\Livros.xml");
                txtDados.Text = dadosXML.ToString();
                btnSelectMany.Enabled = true;
            }
            catch (Exception ex)
            {
                MessageBox.Show("Erro ao carregar XML : " + ex.Message);
            }
        }

        private void btnSelectMany_Click(object sender, EventArgs e)
        {
            string[] strAutores = { "Jose", "David" };

            var livros = strAutores.SelectMany(n => GetLivros(n));

            foreach (var objBook in livros)
            {
                txtXML.Text += "Livro : " + objBook.Element("Titulo").Value + "  =>  Autor : " + objBook.Element("Autor").Element("Nome").Value + "\r\n";
            }
        }

        public IEnumerable<XElement> GetLivros(string autor)
        {
            XDocument objDoc = XDocument.Load(@"c:\dados\XML\Livros.xml");

            var objQuery = objDoc.Descendants("Livro")
                            .Where(b => b.Elements("Autor")
                                         .Elements("Nome")
                                         .Any(aut => (string)aut == autor));

            return objQuery;
        }
    }
}
